# coding: UTF-8

from __future__ import unicode_literals
import addonHandler, globalPluginHandler, globalVars, gui, threading, time, wx
from logHandler import log
from .constants import *
from .userDic import dictionaryEditorUi, utils
from . import updater

try:
	import addonHandler
	addonHandler.initTranslation()
except:
	_ = lambda x : x

def isInMessageBox():
	if hasattr(gui.message, "isModalMessageBoxActive"):
		return gui.message.isModalMessageBoxActive()
	else:
		return gui.message.isInMessageBox()

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	def __init__(self):
		super(globalPluginHandler.GlobalPlugin, self).__init__()
		self.autoUpdateChecker = updater.AutoUpdateChecker()
		self.autoUpdateChecker.updateCheck()

		self.rootMenu = wx.Menu()
		self.dictionaryEditorItem = self.rootMenu.Append(wx.ID_ANY, _("&Dictionary editor"), _("Edit the AquesTalk user dictionary."))
		gui.mainFrame.sysTrayIcon.Bind(wx.EVT_MENU, self.onDictionaryEditor, self.dictionaryEditorItem)
		self.rootMenuItem = gui.mainFrame.sysTrayIcon.menu.Insert(2, wx.ID_ANY, _("AquesTalk"), self.rootMenu)

	def terminate(self):
		super(GlobalPlugin, self).terminate()
		try:
			gui.mainFrame.sysTrayIcon.menu.Remove(self.rootMenuItem)
		except:
			pass

	def onDictionaryEditor(self, evt):
		if isInMessageBox(): return
		if not utils.get_synth():
			gui.messageBox(_("Select AquesTalk voice engine."), _("Error"), style=wx.CENTER | wx.ICON_WARNING)
			return
		gui.mainFrame._popupSettingsDialog(dictionaryEditorUi.DictionaryEditorDialog)
