# coding: UTF-8

import os
from io import StringIO
try:
	from .. import csv
except:
	import csv
from .paths import *

class DicEntry:
	def __init__(self, pattern, replacement, part):
		self.pattern = pattern
		self.replacement = replacement
		self.part = part

def load_from_csv(filepath = dic_csv_path):
	if not os.path.isfile(filepath): return []
	ret = []
	fp = open(filepath, "r", encoding = "utf-8")
	reader = csv.reader(fp)
	for row in reader:
		ret.append(DicEntry(row[0], row[1], int(row[2])))
	fp.close()
	return ret

def save_to_csv(dic_list, filepath = dic_csv_path):
	fp = StringIO()
	writer = csv.writer(fp, delimiter = ",", quotechar = '"', quoting = csv.QUOTE_MINIMAL)
	for elem in dic_list:
		writer.writerow([elem.pattern, elem.replacement, elem.part])
	csv_content = fp.getvalue()
	fp.close()
	fp = open(filepath, "w", encoding = "utf-8", newline = "")
	fp.write(csv_content)
	fp.close()
	return
