# coding: UTF-8

import speech, synthDriverHandler

try:
	from speech.commands import LangChangeCommand
except:
	from speech import LangChangeCommand

def get_synth():
	synth = synthDriverHandler.getSynth()
	attr_list = [
		"aquestalk_import_user_dic",
		"aquestalk_export_user_dic",
		"aquestalk_check_word",
		"aquestalk_pos_code_list"
	]
	return synth if all(hasattr(synth, attr) for attr in attr_list) else None

def test_speech(pattern, replacement, pos_code):
	synth = get_synth()
	if synth:
		ret = synth.aquestalk_check_word(pattern, replacement, pos_code)
		speech.cancelSpeech()
		synth.cancel()
		synth.speak([
			LangChangeCommand("ja_aquestalk"),
			replacement,
			LangChangeCommand("ja")
		])
