# coding: UTF-8

import queue, threading
from logHandler import log

bgThread = None
bgQueue = None
isSpeaking = False

class BgThread(threading.Thread):
	def __init__(self):
		threading.Thread.__init__(self)
		self.setDaemon(True)

	def run(self):
		global isSpeaking
		while True:
			func, args, kwargs = bgQueue.get()
			if not func: break
			try:
				func(*args, **kwargs)
			except:
				log.error("Error running function from queue", exc_info=True)
			finally:
				isSpeaking = False
				bgQueue.task_done()

def execWhenDone(func, *args, **kwargs):
	global bgQueue
	mustBeAsync = kwargs.pop("mustBeAsync", False)
	if bgQueue and (mustBeAsync or bgQueue.unfinished_tasks != 0):
		bgQueue.put((func, args, kwargs))
	else:
		func(*args, **kwargs)

def initialize():
	global bgThread, bgQueue
	bgQueue = queue.Queue()
	bgThread = BgThread()
	bgThread.start()

def terminate():
	global bgThread, bgQueue
	bgQueue.put((None, None, None))
	bgThread.join()
	bgThread = None
	bgQueue = None
